Index: src/Parser/parser.cc
===================================================================
--- src/Parser/parser.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/Parser/parser.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -80,4 +80,5 @@
 #include "lex.h"
 #include "ParseNode.h"
+#include "TypeData.h"
 #include "LinkageSpec.h"
 
@@ -89,5 +90,5 @@
 
 /* Line 268 of yacc.c  */
-#line 92 "Parser/parser.cc"
+#line 93 "Parser/parser.cc"
 
 /* Enabling traces.  */
@@ -324,5 +325,5 @@
 
 /* Line 293 of yacc.c  */
-#line 107 "parser.yy"
+#line 108 "parser.yy"
 
 	Token tok;
@@ -339,5 +340,5 @@
 
 /* Line 293 of yacc.c  */
-#line 342 "Parser/parser.cc"
+#line 343 "Parser/parser.cc"
 } YYSTYPE;
 # define YYSTYPE_IS_TRIVIAL 1
@@ -351,5 +352,5 @@
 
 /* Line 343 of yacc.c  */
-#line 354 "Parser/parser.cc"
+#line 355 "Parser/parser.cc"
 
 #ifdef short
@@ -982,78 +983,78 @@
 static const yytype_uint16 yyrline[] =
 {
-       0,   279,   279,   285,   294,   295,   296,   300,   301,   302,
-     306,   307,   311,   315,   316,   320,   321,   327,   329,   331,
-     333,   335,   337,   342,   343,   349,   351,   353,   354,   356,
-     357,   359,   362,   367,   368,   374,   375,   376,   381,   383,
-     388,   389,   393,   395,   397,   399,   401,   406,   407,   409,
-     411,   413,   415,   417,   423,   425,   427,   429,   431,   433,
-     435,   437,   442,   443,   444,   445,   449,   450,   452,   457,
-     458,   460,   462,   467,   468,   470,   475,   476,   478,   483,
-     484,   486,   488,   490,   495,   496,   498,   503,   504,   509,
-     510,   515,   516,   521,   522,   527,   528,   533,   534,   536,
-     538,   543,   548,   549,   551,   553,   559,   560,   566,   568,
-     570,   572,   577,   578,   583,   584,   585,   586,   587,   588,
-     589,   590,   591,   592,   596,   597,   603,   604,   610,   611,
-     612,   613,   614,   615,   616,   617,   621,   626,   628,   638,
-     639,   644,   646,   648,   650,   654,   655,   660,   665,   668,
-     670,   672,   677,   679,   687,   688,   690,   694,   695,   700,
-     701,   706,   707,   711,   716,   717,   721,   723,   729,   730,
-     734,   736,   738,   740,   746,   747,   751,   752,   756,   758,
-     760,   765,   767,   772,   774,   778,   781,   785,   788,   792,
-     794,   796,   801,   803,   805,   814,   816,   818,   823,   825,
-     830,   843,   844,   849,   851,   856,   860,   862,   864,   866,
-     870,   872,   876,   877,   881,   885,   886,   892,   894,   898,
-     899,   904,   906,   910,   911,   915,   917,   921,   922,   926,
-     927,   931,   932,   947,   948,   949,   950,   951,   955,   960,
-     967,   977,   982,   987,   995,  1000,  1005,  1010,  1015,  1023,
-    1045,  1050,  1057,  1059,  1066,  1071,  1076,  1087,  1092,  1097,
-    1102,  1107,  1116,  1121,  1129,  1130,  1131,  1132,  1138,  1143,
-    1151,  1152,  1153,  1154,  1158,  1159,  1160,  1161,  1166,  1167,
-    1176,  1177,  1182,  1183,  1188,  1190,  1192,  1194,  1196,  1199,
-    1198,  1210,  1211,  1213,  1223,  1224,  1229,  1233,  1235,  1237,
-    1239,  1241,  1243,  1245,  1247,  1252,  1254,  1256,  1258,  1260,
-    1262,  1264,  1266,  1268,  1270,  1272,  1274,  1280,  1281,  1283,
-    1285,  1287,  1292,  1293,  1299,  1300,  1302,  1304,  1309,  1311,
-    1313,  1315,  1320,  1321,  1323,  1325,  1330,  1331,  1333,  1338,
-    1339,  1341,  1343,  1348,  1350,  1352,  1357,  1358,  1362,  1364,
-    1366,  1368,  1370,  1375,  1377,  1382,  1384,  1389,  1390,  1392,
-    1393,  1398,  1399,  1401,  1403,  1408,  1410,  1416,  1417,  1419,
-    1422,  1425,  1430,  1431,  1436,  1441,  1445,  1447,  1449,  1454,
-    1456,  1462,  1463,  1471,  1472,  1476,  1477,  1478,  1480,  1482,
-    1489,  1490,  1492,  1494,  1499,  1500,  1506,  1507,  1511,  1512,
-    1517,  1518,  1519,  1521,  1529,  1530,  1532,  1535,  1537,  1541,
-    1542,  1543,  1545,  1547,  1551,  1556,  1564,  1565,  1574,  1576,
-    1581,  1582,  1583,  1587,  1588,  1589,  1593,  1594,  1595,  1599,
-    1600,  1601,  1606,  1607,  1608,  1609,  1615,  1616,  1621,  1622,
-    1626,  1627,  1628,  1629,  1644,  1645,  1650,  1651,  1657,  1659,
-    1662,  1664,  1666,  1689,  1690,  1692,  1694,  1699,  1700,  1702,
-    1707,  1712,  1713,  1719,  1718,  1722,  1726,  1728,  1730,  1736,
-    1737,  1742,  1747,  1749,  1754,  1756,  1757,  1759,  1764,  1766,
-    1768,  1773,  1775,  1780,  1785,  1793,  1799,  1798,  1812,  1813,
-    1818,  1819,  1823,  1828,  1833,  1841,  1846,  1857,  1858,  1869,
-    1870,  1876,  1877,  1881,  1882,  1883,  1886,  1885,  1896,  1901,
-    1906,  1912,  1921,  1927,  1933,  1939,  1945,  1953,  1959,  1967,
-    1973,  1982,  1983,  1984,  1988,  1992,  1994,  1997,  1999,  2003,
-    2004,  2008,  2012,  2013,  2016,  2018,  2019,  2023,  2024,  2025,
-    2026,  2060,  2061,  2062,  2063,  2067,  2072,  2077,  2079,  2081,
-    2086,  2088,  2090,  2092,  2097,  2099,  2109,  2110,  2111,  2115,
-    2117,  2119,  2124,  2126,  2128,  2133,  2135,  2137,  2146,  2147,
-    2148,  2152,  2154,  2156,  2161,  2163,  2165,  2170,  2172,  2174,
-    2189,  2190,  2191,  2192,  2196,  2197,  2202,  2204,  2206,  2211,
-    2213,  2215,  2217,  2222,  2224,  2226,  2236,  2237,  2238,  2239,
-    2243,  2245,  2247,  2252,  2254,  2256,  2258,  2263,  2265,  2267,
-    2298,  2299,  2300,  2301,  2305,  2310,  2318,  2320,  2322,  2327,
-    2329,  2334,  2336,  2350,  2351,  2352,  2356,  2358,  2360,  2362,
-    2364,  2369,  2370,  2372,  2374,  2379,  2381,  2383,  2389,  2391,
-    2393,  2397,  2399,  2401,  2403,  2417,  2418,  2419,  2423,  2425,
-    2427,  2429,  2431,  2436,  2437,  2439,  2441,  2446,  2448,  2450,
-    2456,  2457,  2459,  2468,  2471,  2473,  2476,  2478,  2480,  2493,
-    2494,  2495,  2499,  2501,  2503,  2505,  2507,  2512,  2513,  2515,
-    2517,  2522,  2524,  2532,  2533,  2534,  2539,  2540,  2544,  2546,
-    2548,  2550,  2552,  2554,  2561,  2563,  2565,  2567,  2569,  2571,
-    2573,  2575,  2577,  2579,  2584,  2586,  2588,  2593,  2619,  2620,
-    2622,  2626,  2627,  2631,  2633,  2635,  2637,  2639,  2641,  2648,
-    2650,  2652,  2654,  2656,  2658,  2663,  2668,  2670,  2672,  2690,
-    2692,  2697,  2698
+       0,   282,   282,   288,   297,   298,   299,   303,   304,   305,
+     309,   310,   314,   318,   319,   323,   324,   330,   332,   334,
+     336,   338,   340,   345,   346,   352,   354,   356,   357,   359,
+     360,   362,   365,   370,   371,   377,   378,   379,   384,   386,
+     391,   392,   396,   398,   400,   402,   404,   409,   410,   412,
+     414,   416,   418,   420,   426,   428,   430,   432,   434,   436,
+     438,   440,   445,   446,   447,   448,   452,   453,   455,   460,
+     461,   463,   465,   470,   471,   473,   478,   479,   481,   486,
+     487,   489,   491,   493,   498,   499,   501,   506,   507,   512,
+     513,   518,   519,   524,   525,   530,   531,   536,   537,   539,
+     541,   546,   551,   552,   554,   556,   562,   563,   569,   571,
+     573,   575,   580,   581,   586,   587,   588,   589,   590,   591,
+     592,   593,   594,   595,   599,   600,   606,   607,   613,   614,
+     615,   616,   617,   618,   619,   620,   624,   631,   633,   643,
+     644,   649,   651,   653,   655,   659,   660,   665,   670,   673,
+     675,   677,   682,   684,   692,   693,   695,   699,   700,   705,
+     706,   711,   712,   716,   721,   722,   726,   728,   734,   735,
+     739,   741,   743,   745,   751,   752,   756,   757,   761,   763,
+     765,   770,   772,   777,   779,   783,   786,   790,   793,   797,
+     799,   801,   806,   808,   810,   819,   821,   823,   828,   830,
+     835,   848,   849,   854,   856,   861,   865,   867,   869,   871,
+     875,   877,   881,   882,   886,   890,   891,   897,   899,   903,
+     904,   909,   911,   915,   916,   920,   922,   926,   927,   931,
+     932,   936,   937,   952,   953,   954,   955,   956,   960,   965,
+     972,   982,   987,   992,  1000,  1005,  1010,  1015,  1020,  1028,
+    1050,  1055,  1062,  1064,  1071,  1076,  1081,  1092,  1097,  1102,
+    1107,  1112,  1121,  1126,  1134,  1135,  1136,  1137,  1143,  1148,
+    1156,  1157,  1158,  1159,  1163,  1164,  1165,  1166,  1171,  1172,
+    1181,  1182,  1187,  1188,  1193,  1195,  1197,  1199,  1201,  1204,
+    1203,  1215,  1216,  1218,  1228,  1229,  1234,  1238,  1240,  1242,
+    1244,  1246,  1248,  1250,  1252,  1257,  1259,  1261,  1263,  1265,
+    1267,  1269,  1271,  1273,  1275,  1277,  1279,  1285,  1286,  1288,
+    1290,  1292,  1297,  1298,  1304,  1305,  1307,  1309,  1314,  1316,
+    1318,  1320,  1325,  1326,  1328,  1330,  1335,  1336,  1338,  1343,
+    1344,  1346,  1348,  1353,  1355,  1357,  1362,  1363,  1367,  1369,
+    1371,  1373,  1375,  1380,  1382,  1387,  1389,  1394,  1395,  1397,
+    1398,  1403,  1404,  1406,  1408,  1413,  1415,  1421,  1422,  1424,
+    1427,  1430,  1435,  1436,  1441,  1446,  1450,  1452,  1454,  1459,
+    1461,  1467,  1468,  1476,  1477,  1481,  1482,  1483,  1485,  1487,
+    1494,  1495,  1497,  1499,  1504,  1505,  1511,  1512,  1516,  1517,
+    1522,  1523,  1524,  1526,  1534,  1535,  1537,  1540,  1542,  1546,
+    1547,  1548,  1550,  1552,  1556,  1561,  1569,  1570,  1579,  1581,
+    1586,  1587,  1588,  1592,  1593,  1594,  1598,  1599,  1600,  1604,
+    1605,  1606,  1611,  1612,  1613,  1614,  1620,  1621,  1626,  1627,
+    1631,  1632,  1633,  1634,  1649,  1650,  1655,  1656,  1662,  1664,
+    1667,  1669,  1671,  1694,  1695,  1697,  1699,  1704,  1705,  1707,
+    1712,  1717,  1718,  1724,  1723,  1727,  1731,  1733,  1735,  1741,
+    1742,  1747,  1752,  1754,  1759,  1761,  1762,  1764,  1769,  1771,
+    1773,  1778,  1780,  1785,  1790,  1798,  1804,  1803,  1817,  1818,
+    1823,  1824,  1828,  1833,  1838,  1846,  1851,  1862,  1863,  1874,
+    1875,  1881,  1882,  1886,  1887,  1888,  1891,  1890,  1901,  1906,
+    1911,  1917,  1926,  1932,  1938,  1944,  1950,  1958,  1964,  1972,
+    1978,  1987,  1988,  1989,  1993,  1997,  1999,  2004,  2005,  2009,
+    2010,  2015,  2021,  2022,  2025,  2027,  2028,  2032,  2033,  2034,
+    2035,  2069,  2071,  2072,  2074,  2079,  2084,  2089,  2091,  2093,
+    2098,  2100,  2102,  2104,  2109,  2111,  2121,  2123,  2124,  2129,
+    2131,  2133,  2138,  2140,  2142,  2147,  2149,  2151,  2160,  2161,
+    2162,  2166,  2168,  2170,  2175,  2177,  2179,  2184,  2186,  2188,
+    2203,  2205,  2206,  2208,  2213,  2214,  2219,  2221,  2223,  2228,
+    2230,  2232,  2234,  2239,  2241,  2243,  2253,  2255,  2256,  2258,
+    2263,  2265,  2267,  2272,  2274,  2276,  2278,  2283,  2285,  2287,
+    2318,  2320,  2321,  2323,  2328,  2333,  2341,  2343,  2345,  2350,
+    2352,  2357,  2359,  2373,  2374,  2376,  2381,  2383,  2385,  2387,
+    2389,  2394,  2395,  2397,  2399,  2404,  2406,  2408,  2414,  2416,
+    2418,  2422,  2424,  2426,  2428,  2442,  2443,  2445,  2450,  2452,
+    2454,  2456,  2458,  2463,  2464,  2466,  2468,  2473,  2475,  2477,
+    2483,  2484,  2486,  2495,  2498,  2500,  2503,  2505,  2507,  2520,
+    2521,  2523,  2528,  2530,  2532,  2534,  2536,  2541,  2542,  2544,
+    2546,  2551,  2553,  2561,  2562,  2563,  2568,  2569,  2573,  2575,
+    2577,  2579,  2581,  2583,  2590,  2592,  2594,  2596,  2598,  2600,
+    2602,  2604,  2606,  2608,  2613,  2615,  2617,  2622,  2648,  2649,
+    2651,  2655,  2656,  2660,  2662,  2664,  2666,  2668,  2670,  2677,
+    2679,  2681,  2683,  2685,  2687,  2692,  2697,  2699,  2701,  2719,
+    2721,  2726,  2727
 };
 #endif
@@ -5007,5 +5008,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 279 "parser.yy"
+#line 282 "parser.yy"
     {
 			typedefTable.enterScope();
@@ -5016,5 +5017,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 285 "parser.yy"
+#line 288 "parser.yy"
     {
 			typedefTable.leaveScope();
@@ -5025,5 +5026,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 294 "parser.yy"
+#line 297 "parser.yy"
     { (yyval.constant) = new ConstantNode( ConstantNode::Integer, (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5032,5 +5033,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 295 "parser.yy"
+#line 298 "parser.yy"
     { (yyval.constant) = new ConstantNode( ConstantNode::Float, (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5039,5 +5040,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 296 "parser.yy"
+#line 299 "parser.yy"
     { (yyval.constant) = new ConstantNode( ConstantNode::Character, (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5046,5 +5047,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 320 "parser.yy"
+#line 323 "parser.yy"
     { (yyval.constant) = new ConstantNode( ConstantNode::String, (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5053,5 +5054,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 321 "parser.yy"
+#line 324 "parser.yy"
     { (yyval.constant) = (yyvsp[(1) - (2)].constant)->appendstr( (yyvsp[(2) - (2)].tok) ); }
     break;
@@ -5060,5 +5061,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 328 "parser.yy"
+#line 331 "parser.yy"
     { (yyval.en) = new VarRefNode( (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5067,5 +5068,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 330 "parser.yy"
+#line 333 "parser.yy"
     { (yyval.en) = new VarRefNode( (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5074,5 +5075,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 332 "parser.yy"
+#line 335 "parser.yy"
     { (yyval.en) = (yyvsp[(1) - (1)].constant); }
     break;
@@ -5081,5 +5082,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 334 "parser.yy"
+#line 337 "parser.yy"
     { (yyval.en) = (yyvsp[(1) - (1)].constant); }
     break;
@@ -5088,5 +5089,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 336 "parser.yy"
+#line 339 "parser.yy"
     { (yyval.en) = (yyvsp[(2) - (3)].en); }
     break;
@@ -5095,5 +5096,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 338 "parser.yy"
+#line 341 "parser.yy"
     { (yyval.en) = new ValofExprNode( (yyvsp[(2) - (3)].sn) ); }
     break;
@@ -5102,5 +5103,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 348 "parser.yy"
+#line 351 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Index ), (yyvsp[(1) - (6)].en), (yyvsp[(4) - (6)].en) ); }
     break;
@@ -5109,5 +5110,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 350 "parser.yy"
+#line 353 "parser.yy"
     { (yyval.en) = new CompositeExprNode( (yyvsp[(1) - (4)].en), (yyvsp[(3) - (4)].en) ); }
     break;
@@ -5116,5 +5117,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 352 "parser.yy"
+#line 355 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::FieldSel ), (yyvsp[(1) - (3)].en), new VarRefNode( (yyvsp[(3) - (3)].tok) )); }
     break;
@@ -5123,5 +5124,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 355 "parser.yy"
+#line 358 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::PFieldSel ), (yyvsp[(1) - (3)].en), new VarRefNode( (yyvsp[(3) - (3)].tok) )); }
     break;
@@ -5130,5 +5131,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 358 "parser.yy"
+#line 361 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::IncrPost ), (yyvsp[(1) - (2)].en) ); }
     break;
@@ -5137,5 +5138,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 360 "parser.yy"
+#line 363 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::DecrPost ), (yyvsp[(1) - (2)].en) ); }
     break;
@@ -5144,5 +5145,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 363 "parser.yy"
+#line 366 "parser.yy"
     { (yyval.en) = 0; }
     break;
@@ -5151,5 +5152,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 369 "parser.yy"
+#line 372 "parser.yy"
     { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_link( (yyvsp[(3) - (3)].en) )); }
     break;
@@ -5158,5 +5159,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 374 "parser.yy"
+#line 377 "parser.yy"
     { (yyval.en) = 0; }
     break;
@@ -5165,5 +5166,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 377 "parser.yy"
+#line 380 "parser.yy"
     { (yyval.en) = (yyvsp[(3) - (3)].en)->set_asArgName( (yyvsp[(1) - (3)].tok) ); }
     break;
@@ -5172,5 +5173,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 382 "parser.yy"
+#line 385 "parser.yy"
     { (yyval.en) = (yyvsp[(7) - (7)].en)->set_asArgName( (yyvsp[(3) - (7)].en) ); }
     break;
@@ -5179,5 +5180,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 384 "parser.yy"
+#line 387 "parser.yy"
     { (yyval.en) = (yyvsp[(9) - (9)].en)->set_asArgName( new CompositeExprNode( new OperatorNode( OperatorNode::TupleC ), (ExpressionNode *)(yyvsp[(3) - (9)].en)->set_link( flattenCommas( (yyvsp[(5) - (9)].en) )))); }
     break;
@@ -5186,5 +5187,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 389 "parser.yy"
+#line 392 "parser.yy"
     { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_link( (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5193,5 +5194,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 394 "parser.yy"
+#line 397 "parser.yy"
     { (yyval.en) = new VarRefNode( (yyvsp[(1) - (1)].tok) ); }
     break;
@@ -5200,5 +5201,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 396 "parser.yy"
+#line 399 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::FieldSel ), new VarRefNode( (yyvsp[(1) - (3)].tok) ), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5207,5 +5208,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 398 "parser.yy"
+#line 401 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::FieldSel ), new VarRefNode( (yyvsp[(1) - (7)].tok) ), (yyvsp[(5) - (7)].en) ); }
     break;
@@ -5214,5 +5215,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 400 "parser.yy"
+#line 403 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::PFieldSel ), new VarRefNode( (yyvsp[(1) - (3)].tok) ), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5221,5 +5222,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 402 "parser.yy"
+#line 405 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::PFieldSel ), new VarRefNode( (yyvsp[(1) - (7)].tok) ), (yyvsp[(5) - (7)].en) ); }
     break;
@@ -5228,5 +5229,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 408 "parser.yy"
+#line 411 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Incr ), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5235,5 +5236,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 410 "parser.yy"
+#line 413 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Decr ), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5242,5 +5243,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 412 "parser.yy"
+#line 415 "parser.yy"
     { (yyval.en) = (yyvsp[(2) - (2)].en); }
     break;
@@ -5249,5 +5250,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 414 "parser.yy"
+#line 417 "parser.yy"
     { (yyval.en) = new CompositeExprNode( (yyvsp[(1) - (2)].en), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5256,5 +5257,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 416 "parser.yy"
+#line 419 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Neg ), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5263,5 +5264,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 418 "parser.yy"
+#line 421 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::PointTo ), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5270,5 +5271,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 424 "parser.yy"
+#line 427 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::SizeOf ), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5277,5 +5278,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 426 "parser.yy"
+#line 429 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::SizeOf ), new TypeValueNode( (yyvsp[(3) - (4)].decl) )); }
     break;
@@ -5284,5 +5285,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 428 "parser.yy"
+#line 431 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Attr ), new VarRefNode( (yyvsp[(1) - (1)].tok) )); }
     break;
@@ -5291,5 +5292,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 430 "parser.yy"
+#line 433 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Attr ), new VarRefNode( (yyvsp[(1) - (4)].tok) ), new TypeValueNode( (yyvsp[(3) - (4)].decl) )); }
     break;
@@ -5298,5 +5299,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 432 "parser.yy"
+#line 435 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Attr ), new VarRefNode( (yyvsp[(1) - (4)].tok) ), (yyvsp[(3) - (4)].en) ); }
     break;
@@ -5305,5 +5306,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 434 "parser.yy"
+#line 437 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::AlignOf ), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5312,5 +5313,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 436 "parser.yy"
+#line 439 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::AlignOf ), new TypeValueNode( (yyvsp[(3) - (4)].decl) )); }
     break;
@@ -5319,5 +5320,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 438 "parser.yy"
+#line 441 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::LabelAddress ), new VarRefNode( (yyvsp[(2) - (2)].tok), true )); }
     break;
@@ -5326,5 +5327,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 442 "parser.yy"
+#line 445 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::AddressOf ); }
     break;
@@ -5333,5 +5334,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 443 "parser.yy"
+#line 446 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::UnPlus ); }
     break;
@@ -5340,5 +5341,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 444 "parser.yy"
+#line 447 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::UnMinus ); }
     break;
@@ -5347,5 +5348,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 445 "parser.yy"
+#line 448 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::BitNeg ); }
     break;
@@ -5354,5 +5355,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 451 "parser.yy"
+#line 454 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Cast ), new TypeValueNode( (yyvsp[(2) - (4)].decl) ), (yyvsp[(4) - (4)].en) ); }
     break;
@@ -5361,5 +5362,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 453 "parser.yy"
+#line 456 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Cast ), new TypeValueNode( (yyvsp[(2) - (4)].decl) ), (yyvsp[(4) - (4)].en) ); }
     break;
@@ -5368,5 +5369,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 459 "parser.yy"
+#line 462 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Mul ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5375,5 +5376,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 461 "parser.yy"
+#line 464 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Div ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5382,5 +5383,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 463 "parser.yy"
+#line 466 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Mod ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5389,5 +5390,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 469 "parser.yy"
+#line 472 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Plus ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5396,5 +5397,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 471 "parser.yy"
+#line 474 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Minus ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5403,5 +5404,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 477 "parser.yy"
+#line 480 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::LShift ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5410,5 +5411,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 479 "parser.yy"
+#line 482 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::RShift ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5417,5 +5418,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 485 "parser.yy"
+#line 488 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::LThan ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5424,5 +5425,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 487 "parser.yy"
+#line 490 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::GThan ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5431,5 +5432,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 489 "parser.yy"
+#line 492 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::LEThan ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5438,5 +5439,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 491 "parser.yy"
+#line 494 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::GEThan ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5445,5 +5446,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 497 "parser.yy"
+#line 500 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Eq ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5452,5 +5453,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 499 "parser.yy"
+#line 502 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Neq ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5459,5 +5460,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 505 "parser.yy"
+#line 508 "parser.yy"
     { (yyval.en) =new CompositeExprNode( new OperatorNode( OperatorNode::BitAnd ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5466,5 +5467,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 511 "parser.yy"
+#line 514 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Xor ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5473,5 +5474,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 517 "parser.yy"
+#line 520 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::BitOr ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5480,5 +5481,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 523 "parser.yy"
+#line 526 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::And ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5487,5 +5488,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 529 "parser.yy"
+#line 532 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Or ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5494,5 +5495,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 535 "parser.yy"
+#line 538 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Cond ), (ExpressionNode *)mkList( (*(yyvsp[(1) - (5)].en), *(yyvsp[(3) - (5)].en), *(yyvsp[(5) - (5)].en) ) ) ); }
     break;
@@ -5501,5 +5502,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 537 "parser.yy"
+#line 540 "parser.yy"
     { (yyval.en)=new CompositeExprNode( new OperatorNode( OperatorNode::NCond ), (yyvsp[(1) - (4)].en), (yyvsp[(4) - (4)].en) ); }
     break;
@@ -5508,5 +5509,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 539 "parser.yy"
+#line 542 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Cond ), (ExpressionNode *)mkList( (*(yyvsp[(1) - (5)].en), *(yyvsp[(3) - (5)].en), *(yyvsp[(5) - (5)].en) ) ) ); }
     break;
@@ -5515,5 +5516,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 550 "parser.yy"
+#line 553 "parser.yy"
     { (yyval.en) =new CompositeExprNode( new OperatorNode( OperatorNode::Assign ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5522,5 +5523,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 552 "parser.yy"
+#line 555 "parser.yy"
     { (yyval.en) =new CompositeExprNode( (yyvsp[(2) - (3)].en), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5529,5 +5530,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 554 "parser.yy"
+#line 557 "parser.yy"
     { (yyval.en) = ( (yyvsp[(2) - (2)].en) == 0 ) ? (yyvsp[(1) - (2)].en) : new CompositeExprNode( new OperatorNode( OperatorNode::Assign ), (yyvsp[(1) - (2)].en), (yyvsp[(2) - (2)].en) ); }
     break;
@@ -5536,5 +5537,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 559 "parser.yy"
+#line 562 "parser.yy"
     { (yyval.en) = new NullExprNode; }
     break;
@@ -5543,5 +5544,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 567 "parser.yy"
+#line 570 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::TupleC ) ); }
     break;
@@ -5550,5 +5551,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 569 "parser.yy"
+#line 572 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::TupleC ), (yyvsp[(3) - (5)].en) ); }
     break;
@@ -5557,5 +5558,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 571 "parser.yy"
+#line 574 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::TupleC ), (ExpressionNode *)(new NullExprNode)->set_link( (yyvsp[(4) - (6)].en) ) ); }
     break;
@@ -5564,5 +5565,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 573 "parser.yy"
+#line 576 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::TupleC ), (ExpressionNode *)(yyvsp[(3) - (7)].en)->set_link( flattenCommas( (yyvsp[(5) - (7)].en) ) ) ); }
     break;
@@ -5571,5 +5572,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 579 "parser.yy"
+#line 582 "parser.yy"
     { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_link( (yyvsp[(3) - (3)].en) ); }
     break;
@@ -5578,5 +5579,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 583 "parser.yy"
+#line 586 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::MulAssn ); }
     break;
@@ -5585,5 +5586,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 584 "parser.yy"
+#line 587 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::DivAssn ); }
     break;
@@ -5592,5 +5593,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 585 "parser.yy"
+#line 588 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::ModAssn ); }
     break;
@@ -5599,5 +5600,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 586 "parser.yy"
+#line 589 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::PlusAssn ); }
     break;
@@ -5606,5 +5607,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 587 "parser.yy"
+#line 590 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::MinusAssn ); }
     break;
@@ -5613,5 +5614,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 588 "parser.yy"
+#line 591 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::LSAssn ); }
     break;
@@ -5620,5 +5621,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 589 "parser.yy"
+#line 592 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::RSAssn ); }
     break;
@@ -5627,5 +5628,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 590 "parser.yy"
+#line 593 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::AndAssn ); }
     break;
@@ -5634,5 +5635,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 591 "parser.yy"
+#line 594 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::ERAssn ); }
     break;
@@ -5641,5 +5642,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 592 "parser.yy"
+#line 595 "parser.yy"
     { (yyval.en) = new OperatorNode( OperatorNode::OrAssn ); }
     break;
@@ -5648,5 +5649,5 @@
 
 /* Line 1806 of yacc.c  */
-#line 598 "parser.yy"
+#line 601 "parser.yy"
     { (yyval.en) = new CompositeExprNode( new OperatorNode( OperatorNode::Comma ), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ); }
     break;
